package br.com.webpublico.<%=modulo%>.entities;

import br.com.webpublico.comum.annotations.*;
import org.hibernate.envers.Audited;<% if(temChaveNegocio) {%>
import br.com.webpublico.comum.chavesnegocio.ChaveNegocio;
import br.com.webpublico.comum.entities.SuperEntidadeComChaveNegocio;
import br.com.webpublico.<%=modulo%>.chavesnegocio.ChaveNegocio<%=classe%>;<%}%>
<%=temCampoDate ? '\nimport java.util.Date;' : ''%><%=temCampoLocalDate ? '\nimport java.time.LocalDate;' : ''%><%=temCampoZonedDateTime ? '\nimport java.time.ZonedDateTime;' : ''%>
import javax.persistence.*;

@Entity
@Audited
@GrupoDiagrama(nome = "<%=modulo%>")
@Etiqueta(value = "<%=etiqueta%>"<%=genero == 'feminino' ? ', genero = "F"' : ''%>)
public class <%=classe%> extends SuperEntidade<%=temChaveNegocio ? 'ComChaveNegocio' : ''%> {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    @Version
    @Column(columnDefinition = "integer DEFAULT 0", nullable = false)
    @Invisivel
    private Integer versao;<%for(fieldId in fields){%> <%=fields[fieldId].annotations.obrigatorio ? '\n    @Obrigatorio' : ''%><%=fields[fieldId].annotations.tabelavel ? '\n    @Tabelavel' : ''%><%=fields[fieldId].annotations.pesquisavel ? '\n    @Pesquisavel' : ''%><%-fields[fieldId].label != fields[fieldId].fieldName ? '\n    @Etiqueta("' + fields[fieldId].label + '")' : ''%><%-fields[fieldId].fieldType.size && fields[fieldId].fieldType.isString ? '\n    @Length(maximo = ' + fields[fieldId].fieldType.size + ')' : ''%><%=fields[fieldId].fieldType.isTime ? '\n    @Temporal(TemporalType.TIMESTAMP)' : ''%><%=fields[fieldId].fieldType.isDate ? '\n    @Temporal(TemporalType.DATE)' : ''%>
    private <%=fields[fieldId].fieldType.type%> <%=fields[fieldId].fieldName%>;<%}%>

    <% if (fieldsObrigatorios.length > 0) {%>public <%=classe%>() {
    }

    public <%=classe%>(<%for(fieldId in fieldsObrigatorios) {%><%=fieldsObrigatorios[fieldId].fieldType.type%> <%=fieldsObrigatorios[fieldId].fieldName%><%=fieldId != fieldsObrigatorios.length - 1 ? ', ' : ''%><%}%>) {<%for(fieldId in fieldsObrigatorios) {%>
        this.<%=fieldsObrigatorios[fieldId].fieldName%> = <%=fieldsObrigatorios[fieldId].fieldName%>;<%}%>
    }

    <%}%>
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer getVersao() {
        return this.versao;
    }
<%for(fieldId in fields){%>
    public <%=fields[fieldId].fieldType.type%> get<%=fields[fieldId].capitalizedFieldName%>() {
        return this.<%=fields[fieldId].fieldName%>;
    }

    public void set<%=fields[fieldId].capitalizedFieldName%>(<%=fields[fieldId].fieldType.type%> <%=fields[fieldId].fieldName%>) {
        this.<%=fields[fieldId].fieldName%> = <%=fields[fieldId].fieldName%>;
    }
<%}%><%if (temChaveNegocio){%>
    @Override
    public ChaveNegocio getChaveNegocio() {
        return new ChaveNegocio<%=classe%>(<%for(fieldId in chaveNegocioFields){%>this.<%=chaveNegocioFields[fieldId].fieldName%><%=fieldId != chaveNegocioFields.length - 1 ? ', ' : ''%><%}%>);
    }
<%}%>
}
