package br.com.webpublico.<%=modulo%>.services;

import br.com.webpublico.comum.services.AbstractServiceIT;
import br.com.webpublico.<%=modulo%>.entities.<%=classe%>;
import br.com.webpublico.comum.exceptions.OperacaoNaoPermitidaException;
import br.com.webpublico.<%=modulo%>.services.<%=classe%>Service;
import org.junit.Before;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.jdbc.JdbcTestUtils;

import static org.hamcrest.CoreMatchers.equalTo;
import static org.hamcrest.CoreMatchers.not;
import static org.hamcrest.CoreMatchers.nullValue;
import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.is;

public class <%=classe%>ServiceIT extends AbstractServiceIT {

    private static final Logger logger = LoggerFactory.getLogger(<%=classe%>ServiceIT.class);
    <%for(fieldId in fields) {%>
    private static final <%=fields[fieldId].fieldType.type%> <%=fields[fieldId].fieldName.toUpperCase()%>_DEFAULT = <%-getRandomValue(fields[fieldId])%>;
    private static final <%=fields[fieldId].fieldType.type%> <%=fields[fieldId].fieldName.toUpperCase()%>_UPDATED = <%-getRandomValue(fields[fieldId])%>;<%}%>

    @Autowired
    private <%=classe%>Service service;

    private <%=classe%> entidade;

    @Before
    public void setUp() {
        entidade = new <%=classe%>();<%for(fieldId in fields) {%>
        entidade.set<%=fields[fieldId].capitalizedFieldName%>(<%=fields[fieldId].fieldName.toUpperCase()%>_DEFAULT);<%}%>
        JdbcTestUtils.deleteFromTables(jdbcTemplate, "<%=variavel%>");
    }

    @Test
    public void create() throws OperacaoNaoPermitidaException {
        entidade.setId(null);
        entidade = service.salvar(entidade);
        assertThat(entidade.getId(), is(not(nullValue())));
    }

    @Test
    public void retrieve() throws OperacaoNaoPermitidaException {
        entidade = service.salvar(entidade);
        <%=classe%> retrieved = service.recuperar(entidade.getId());
        assertThat(entidade, is(equalTo(retrieved)));
    }

    @Test
    public void update() throws OperacaoNaoPermitidaException {
        entidade = service.salvar(entidade);<%for(fieldId in fields) {%>
        entidade.set<%=fields[fieldId].capitalizedFieldName%>(<%=fields[fieldId].fieldName.toUpperCase()%>_UPDATED);<%}%>
        <%=classe%> updated = service.salvar(entidade);
        assertThat(updated, is(equalTo(entidade)));
    }

    @Test
    public void delete() throws OperacaoNaoPermitidaException {
        entidade = service.salvar(entidade);
        Long id = entidade.getId();
        service.remover(entidade);
        int count = jdbcTemplate.queryForObject("SELECT count(*) FROM <%=classe%> WHERE id = ?", new Object[] { id }, Integer.class);
        assertThat(count, is(equalTo(0)));
    }
}
